%Exercise 1e
%
%The population growth of flies is calculated and plotted.
%
%INPUT
%=====
%day        days to pass
%threshold  population threshold
%
% WARNING:  Calculation of the growth stops if the threshold is reached
%           before the desired days.
%
%OUTPUT
%=====%
%nP         vector of the population per day
%plot(nP)   plot of the population growth

%%

function nP = flypop(day, threshold)

%test for correct user inputs

if round(day)~=day | round(threshold)~=threshold
    warning('Integer input more adequate!')
end

%set initial parameters

f = 0.2;        %fertility
m = 0.1;        %mortality
P = 500;        %population size
th= threshold;  %population threshold
nP= [];         %population vector
d = 0;          %day counter   

%calculate population growth

while d<day & P<=th         %either the day or threshold sets the limit
    P = (1 + f - m) * P;    %population today
    nP= [nP P];             %append todays population to the vector
    d = d + 1;              %one more day has passed
end

%if the last population exceeds the threshold, remove it

if nP>th
    nP(end) = []
end


%check if threshold is reached before the desired day
%and give warning

if d<day
    warning(strcat('Treshold reached after ',num2str(d), ' days!'))
end

%plot the population growth

plot(nP)
title('Growth of a fly population')
xlabel('day')
ylabel('flies')

%vary the fertility values

em = input('Want to see your results with different fertility values (Y)es/(N)o)?', 's')

%make shure the first letter is uppercase
em = upper(em(1)); 

switch em
    case {'N'}
        disp('pffff, whatever...')
    otherwise
        ff = [0.2 0.3 0.4 0.5 0.6];
        colors = ['b', 'g', 'r', 'c', 'k']
        figure()
        hold on
        for i=1:length(ff)
            dd = 0;
            P  = 500;
            pP = [];
            f  = ff(i);
            while dd<d      %final day from the initial calculationt is the limit
                P = (1 + f - m) * P;    %population today
                pP= [pP P];             %append todays population to the vector
                dd = dd + 1;              %one more day has passed
            end
            plot(pP, colors(i))
            pause
        end
        title('Growth with differend fertility values')
        xlabel('day')
        ylabel('flies')
        legend('f=0.2', 'f=0.3', 'f=0.4', 'f=0.5', 'f=0.6', 'Location', 'NorthWest')
        hold off
end
            